import net.sf.flashlib.util.Delegate;

import net.sf.emff.EMFF;
import net.sf.emff.Track;
import net.sf.emff.UpdateUtil;

import net.sf.emff.configuration.ConfigurationFlashVars;



/**
 * The "silk" skin.
 * 
 * @version  0.0.1
 * @author   Marc Reichelt
 */
class Skin {
	
	private static var skin : Skin = null;
	
	private var emff : EMFF = null;
	
	private var previousMC : MovieClip = null;
	private var playMC : MovieClip = null;
	private var pauseMC : MovieClip = null;
	private var stopMC : MovieClip = null;
	private var nextMC : MovieClip = null;
	private var textField : TextField = null;
	
	/**
	 * Main method that simply creates a new skin.
	 */
	public static function main() : Void {
		
		if (UpdateUtil.getInstance().updateNeeded()) {
			return;
		}
		
		skin = new Skin();
	}
	
	/**
	 * Initialization of this skin.
	 */
	private function Skin() {
		// read configuration and create new player
		emff = new EMFF( new ConfigurationFlashVars() );
		
		// save
		previousMC = _root.previousMC;
		playMC = _root.playMC;
		pauseMC = _root.pauseMC;
		stopMC = _root.stopMC;
		nextMC = _root.nextMC;
		
		// create text field
		_root.createTextField("textField", _root.getNextHighestDepth(), 0, -3, 0, 0);
		textField = _root.textField;
		textField.autoSize = true;
		textField.selectable = false;
		
		var textFormat : TextFormat = new TextFormat();
		textFormat.color = 0x000000;
		textFormat.font = "emffFont";
		textFormat.size = 8;
		textField.embedFonts = true;
		textField.setNewTextFormat(textFormat);
		
		var emff : EMFF = this.emff;
		var textField : TextField = this.textField;
		
		// set actions
		previousMC.onRelease = function() : Void {
			textField.text = "";
			textField._x = 0;
			emff.previous();
		};
		playMC.onRelease = Delegate.create(emff, emff.play);
		pauseMC.onRelease = Delegate.create(emff, emff.pause);
		stopMC.onRelease = Delegate.create(emff, emff.stop);
		nextMC.onRelease = function() : Void {
			textField.text = "";
			textField._x = 0;
			emff.next();
		};
		
		_root.onEnterFrame = Delegate.create(this, enterFrame);
	}
	
	/**
	 * Method that is activated every frame and will refresh the visualisation.
	 */
	private function enterFrame() : Void {
		
		var track : Track = emff.getActiveTrack();
		textField._width = 0;
		
		if (track != null) {
			if (track.getCreator() == "" && track.getTitle() == "") {
				textField.text = "";
			} else if (track.getCreator() != "" && track.getTitle() == "") {
				textField.text = track.getCreator();
			} else if (track.getCreator() == "" && track.getTitle() != "") {
				textField.text = track.getTitle();
			} else {
				textField.text = track.getCreator() + " - " + track.getTitle();
			}
		} else {
			textField.text = "";
		}
		
		if (textField._width < 84) {
			// static title
			
			textField._x = 0;
		} else {
			// dynamic title
			
			textField._x--;
			
			// left side
			if (textField._x + textField._width < 0) {
				textField._x = 84;
			}
		}
	}
	
}
