/**
 * Implementation of a configuration.
 * 
 * @version  0.0.5
 * @author   Marc Reichelt
 */
/* abstract */ class net.sf.emff.configuration.Configuration {
	
	/**
	 * Contains the URL from where an external playlist should be loaded -
	 * and <code>null</code> if no external playlist should be loaded.
	 */
	public var playlist : String = null;
	
	/**
	 * URLs for sound files (separated by commas).
	 */
	public var src : String = null;
	
	/**
	 * The volume. By default the volume is set to 100 (maximum).
	 */
	public var volume : Number = 100;
	
	/**
	 * The balance. By default the balance is set to 0 (center).
	 */
	public var balance : Number = 0;
	
	/**
	 * Indicates whether the sound file should be loaded automatically.
	 */
	public var autoload : Boolean = false;
	
	/**
	 * Indicates whether the sound should start automatically.
	 */
	public var autostart : Boolean = false;
	
	/**
	 * Indicates if the playlist should be repeated.
	 */
	public var repeat : Boolean = false;
	
	/**
	 * Indicates if the playlist should be played in a random mode.
	 */
	public var shuffle : Boolean = false;
	
	/**
	 * Should the key shortcuts be enabled?
	 */
	public var shortcuts : Boolean = false;
	
	/**
	 * Group name (if more EMFF instances are grouped).
	 */
	public var groupname : String = "";
	
	
	
	/**
	 * Create a new configuration.
	 */
	public /* abstract */ function Configuration() {
		// this is just a placeholder
		// subclasses of this class should implementate this function
	}
	
}
