import net.sf.flashlib.lang.Exception;

/**
 * Thrown to indicate that the code has attempted to cast an object to a subclass of which it is not an instance.
 * 
 * @version 0.1.0
 * @author  Marc Reichelt
 */
class net.sf.flashlib.lang.ClassCastException extends Exception {
	
	/**
	 * Creates a new ClassCastException.
	 * 
	 * @param  message  The message. If no message is given, the message is "".
	 */
	public function ClassCastException(message : String) {
		super(
			(message == null)
			? ""
			: message
		);
	}
	
	
	
	/**
	 * Returns the name of this exception.
	 * 
	 * @return  Name of this exception.
	 * @see     net.sf.flashlib.lang.Exception#getName()
	 */
	public function getName() : String {
		return "ClassCastException";
	}
	
}
