import net.sf.flashlib.util.Observable;



/**
 * A observer is for classes that want to be informed by an object of type
 * <code>Observable</code> that it has changed.
 * 
 * @author  Marc Reichet
 * @version 0.0.1
 */
interface net.sf.flashlib.util.Observer {
	
	/**
	 * Invoked automatically by an observed object when it changes.
	 * 
	 * @param  observable  The observed object (an instance of Observable).
	 * @param  obj         An arbitrary data object sent by the observed object.
	 */
	public function update(observable : Observable, obj : Object) : Void;
	
}
