import net.sf.flashlib.util.Delegate;

import net.sf.flashlib.util.logging.Logger;
import net.sf.flashlib.util.logging.LogMessage;

import net.sf.flashlib.lang.NullPointerException;

// TODO: Docs
// TODO: Implement missing functions

/**
 * A logger that sends all messages to a specific server via XMLSocket.
 * 
 * @version 0.0.1
 * @author  Marc Reichelt
 */
class net.sf.flashlib.util.logging.XMLLogger extends Logger {
	
	public static /* const */ var MAX_TEXT : Number = 1024 * 1024 * 1024;
	
	private var url : String;
	private var username : String;
	private var password : String;
	private var method : String;
	private var isBusy : Boolean = false;
	private var buffer : Array = new Array();
	private var xmlSocket : XMLSocket;
	
	
	
	/**
	 * Creates a new XML logger with the given parameters.
	 * 
	 * @param  url       The URL the XMLSocket will connect to. The default is "127.0.0.1".
	 * @param  port      The port the XMLSocket will connect to. Default: 4321.
	 */
	public function XMLLogger(url : String, port : Number) {
		
		// get parameters, set default values if the parameter isn't specified or is incorrect
		this.url = (url == null) ? "127.0.0.1" : url;
		this.port = (port == null) ? "4321" : port;
		
		// initialise connection
		xmlSocket = new XMLSocket();
		xmlSocket.connect(url, port);
		//TODO
	}
	
	
	
	public function log(message : LogMessage) : Void {
		
		if (message == null) {
			throw new NullPointerException("The message must not be null.");
		}
		
		// check if the level value of the message is lower than or equal to our level value
		if (message.getLevel().getValue() >= this.getLevel().getValue()) {
			
			// add message to buffer
			buffer.push(message);
			
			sendToServer();
		}
		
	}
	
	private function sendToServer() : Void {
		if (!isBusy) {
			isBusy = true;
			
			var xml : XML = new XML();
			var root = xml.createElement("logger");
			xml.appendChild(root);
			
			
			loadVars.text += LogMessage(buffer.shift()).toString();
			
			// send data
			loadVars.sendAndLoad(url, loadVars, method);
			
		}
	}
	
	private function onLoad(success : Boolean) : Void {
		
		if (!success) {
			// a failure occured
			// TODO: throw own exception
		} else {
			// no failure
		}
		
		createNewLoadVars();
		isBusy = false;
		
		if (buffer.length > 0) {
			sendToServer();
		}
	}
	
}
